module G5RepsClient
  class SaveLeadRequest

    def self.execute(enterprise_key, wsdl, community_id, lead)
      message = { enterprise_key: "#{enterprise_key}",
                  community_id: "#{community_id}",
                  new_contact: camelcase_keys(lead),
                  new_prospect: [{}]
                }

      SavonAdapter.call(:save_lead, message, wsdl)
    end

    def self.camelcase_keys(lead )
      converted_lead = [{}]
      lead.keys.each do |k|
        key = k.to_s.split('_').collect(&:capitalize).join
        converted_lead.first.merge!("#{key}" => "#{lead[k]}")
      end
      converted_lead
    end

  end

end