require "g5_reps_client/version"
require "g5_reps_client/client"
require "g5_reps_client/requests/get_communities_request"
require "g5_reps_client/requests/get_pick_lists_request"
require "g5_reps_client/requests/save_lead_request"
require "g5_reps_client/soap_adapters/savon_adapter"
require "savon"

module G5RepsClient

  SENSITIVE_FIELDS = [
    "address1",
    "email",
    "phone"
  ]

  def self.new(key, wsdl)
    client = G5RepsClient::Client.new(key, wsdl)
  end

end
