module G5RepsClient
  class Client


    def initialize(key, wsdl)
      @key = key
      @wsdl = wsdl
    end

    def get_communities
      request = GetCommunitiesRequest.execute(@key, @wsdl)
    end

    def get_pick_lists(community_id)
      request = GetPickListsRequest.execute(@key, @wsdl, "#{community_id}")
    end

    def save_lead(community_id, lead)
      request = SaveLeadRequest.execute(@key, @wsdl, "#{community_id}", lead)
    end


  end
end